#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <arpa/inet.h>



int initialized=0;
int sock_id;

int initializeSocketUDP(char* service)
{
	struct addrinfo precisions, *resultat=NULL, *origine; // On stocke dans précisions nos besoins pour le socket, dans resultat l'adresse qui respectera les reqêtes

	memset(&precisions, 0, sizeof precisions);
	precisions.ai_family = AF_UNSPEC;
	precisions.ai_socktype = SOCK_DGRAM;
	//precisions.ai_flags = AI_PASSIVE;
	
	if(getaddrinfo(NULL, service, &precisions, &origine)<0) { fprintf(stderr, "Erreur getaddrinfo\n"); return(-1); }
	
	int n=0;
	
	for(struct addrinfo* i=origine; i!=NULL && resultat==NULL; i=i->ai_next)
	{
		printf("%d - ", n);
		if(i->ai_family==AF_INET)
		{
			resultat=i;
			printf("Test : %d", origine->ai_addrlen);
		}

		printf("\n");	
		n++;
	}

	struct sockaddr_in* test=(struct sockaddr_in*)(resultat->ai_addr);
	printf("Addr : %x\n", test->sin_addr.s_addr);
	if((sock_id=socket(resultat->ai_family, resultat->ai_socktype, resultat->ai_protocol))<0) { fprintf(stderr, "Erreur socket\n"); return(-1); }

	int val=1;
	
	if(setsockopt(sock_id, SOL_SOCKET, SO_REUSEADDR|SO_BROADCAST, &val, sizeof(val))<0) { fprintf(stderr, "Erreur setsockopt\n"); return(-1); }

	if(bind(sock_id, resultat->ai_addr, resultat->ai_addrlen)) { fprintf(stderr, "Erreur bind\n"); return(-1); }


	freeaddrinfo(origine);

	initialized=1;
}



int sendUDPBroadcast(char* message, int port)
{
	static struct sockaddr_in addrUDP;
	addrUDP.sin_family=AF_INET;
	addrUDP.sin_port=(uint16_t)port;

	struct in_addr tmpadd={0xffffffff};	
	addrUDP.sin_addr=tmpadd;
	
	if(initialized!=1)
	{
		printf("Initialize via Broadcast\n");
		char tmp_str[15];
		sprintf(tmp_str, "%d", port);
		initializeSocketUDP( tmp_str );
	}

	if(sendto(sock_id, message, sizeof(message), 0, (struct sockaddr*) &addrUDP, sizeof(addrUDP)) < 0) { fprintf(stderr, "Erreur sendto\n"); return(-1);} 
}

int sendUDPUnicast(char* address, char* message, int port)
{
	static struct sockaddr_in addrUDP;
	addrUDP.sin_family=AF_INET;
	addrUDP.sin_port=(uint16_t)port;

	inet_aton(address, &(addrUDP.sin_addr)); // Converti l'écriture string de format a.b.c.d en format Internet

	

	if(initialized!=1)
	{
		printf("Initialize via Unicast\n");
		char tmp_str[15];
		sprintf(tmp_str, "%d", port);
		initializeSocketUDP( tmp_str );
	}

	if(sendto(sock_id, message, sizeof(message), 0, (struct sockaddr*) &addrUDP, sizeof(addrUDP)) < 0 ) { fprintf(stderr, "Error sendto\n"); return(-1); }
}




int main(void)
{
	sendUDPBroadcast("Broadwesh", 2020);
	sendUDPUnicast("255.255.255.255", "Uniwesh", 2020);
	return(1);
	close(sock_id);
}
